<?php
define('THEME_URL', get_template_directory_uri());
define('THEME_PATH', get_template_directory());
define('SITE_URL', get_site_url());

include_once 'inc/styles-scripts.php';

add_action( 'after_setup_theme', 'theme_setup' );
if ( ! function_exists( 'theme_setup' ) ):
function theme_setup() {
	global $wp_roles;

	// This theme styles the visual editor with editor-style.pps to match the theme style.
	add_editor_style();

	// This theme uses Featured Images (also known as post thumbnails) for per-post/per-page Custom Header images
	add_theme_support( 'post-thumbnails' );
}
endif; // theme_setup

// Remove generator meta tag
remove_action('wp_head', 'wp_generator');

// Move Yoast to bottom
function yoasttobottom() {
	return 'low';
}
add_filter( 'wpseo_metabox_prio', 'yoasttobottom');

/*Options Page*/
function my_acf_options_page_settings($settings)
{
	//$settings['title'] = 'Global';
	$settings['pages'] = array('General', 'Users');
	return $settings;
}
add_filter('acf/options_page/settings', 'my_acf_options_page_settings');